### R code from vignette source 'robflreg.Rnw'

###################################################
### code chunk number 1: robflreg.Rnw:136-142
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 5, n.gp = 101)
Y <- sim.data$Y
plot(Y, type = "p", pch = 16, xlab = "Index", ylab = "", main = "Response")


###################################################
### code chunk number 2: robflreg.Rnw:145-153
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 5, n.gp = 101)
X <- sim.data$X
fX1 <- fdata(X[[1]], argvals = seq(0, 1, length.out = 101))
plot(fX1, lty = 1, ylab = "", xlab = "",
main = expression(X[1](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 3: robflreg.Rnw:156-164
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 5, n.gp = 101)
X <- sim.data$X
fX2 <- fdata(X[[2]], argvals = seq(0, 1, length.out = 101))
plot(fX2, lty = 1, ylab = "", xlab = "",
main = expression(X[2](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 4: robflreg.Rnw:167-175
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 5, n.gp = 101)
X <- sim.data$X
fX3 <- fdata(X[[3]], argvals = seq(0, 1, length.out = 101))
plot(fX3, lty = 1, ylab = "", xlab = "Grid point",
main = expression(X[3](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 5: robflreg.Rnw:178-186
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 5, n.gp = 101)
X <- sim.data$X
fX4 <- fdata(X[[4]], argvals = seq(0, 1, length.out = 101))
plot(fX4, lty = 1, ylab = "", xlab = "Grid point",
main = expression(X[4](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 6: robflreg.Rnw:189-197
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 5, n.gp = 101)
X <- sim.data$X
fX5 <- fdata(X[[5]], argvals = seq(0, 1, length.out = 101))
plot(fX5, lty = 1, ylab = "", xlab = "Grid point",
main = expression(X[5](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 7: robflreg.Rnw:269-277
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
Y <- sim.data$Y
fY <- fdata(Y, argvals = seq(0, 1, length.out = 101))
plot(fY, lty = 1, ylab = "", xlab = "",
main = "Response", mgp = c(2, 0.5, 0))


###################################################
### code chunk number 8: robflreg.Rnw:280-288
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
X <- sim.data$X
fX1 <- fdata(X[[1]], argvals = seq(0, 1, length.out = 101))
plot(fX1, lty = 1, ylab = "", xlab = "",
main = expression(X[1](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 9: robflreg.Rnw:291-299
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
X <- sim.data$X
fX2 <- fdata(X[[2]], argvals = seq(0, 1, length.out = 101))
plot(fX2, lty = 1, ylab = "", xlab = "",
main = expression(X[2](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 10: robflreg.Rnw:302-310
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
X <- sim.data$X
fX3 <- fdata(X[[3]], argvals = seq(0, 1, length.out = 101))
plot(fX3, lty = 1, ylab = "", xlab = "Grid point",
main = expression(X[3](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 11: robflreg.Rnw:313-321
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
X <- sim.data$X
fX4 <- fdata(X[[4]], argvals = seq(0, 1, length.out = 101))
plot(fX4, lty = 1, ylab = "", xlab = "Grid point",
main = expression(X[4](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 12: robflreg.Rnw:324-332
###################################################
library(robflreg)
library(fda.usc)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
X <- sim.data$X
fX5 <- fdata(X[[5]], argvals = seq(0, 1, length.out = 101))
plot(fX5, lty = 1, ylab = "", xlab = "Grid point",
main = expression(X[4](s)), mgp = c(2, 0.5, 0))


###################################################
### code chunk number 13: robflreg.Rnw:422-439
###################################################
library(robflreg)
# Generate a dataset with five functional predictors and 200
# observations at 101 equally spaced point in the interval [0, 1]
# for each variable for the function-on-function regression model
set.seed(123)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)
# Response variable
Y <- sim.data$Y
gpY <- seq(0, 1, length.out = 101) # grid points

# Perform robust functional principal component analysis on the response variable Y
rob.fpca <- getPCA(data = Y, nbasis = 20, ncomp = 4, gp = gpY, emodel = "robust")

# Principal components
PCs <- rob.fpca$PCAcoef

plot(PCs, xlab = "Grid point", ylab = "Values")


###################################################
### code chunk number 14: robflreg.Rnw:524-534
###################################################
library(robflreg)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 3, n.gp = 101)
Y <- sim.data$Y
X <- sim.data$X

gp <- rep(list(seq(0, 1, length.out = 101)), 3) # grid points of Xs
model.fit <- rob.sf.reg(Y, X, emodel = "robust", fmodel = "tau", gp = gp)
coefs <- get.sf.coeffs(model.fit)
plot_sf_coeffs(object = coefs, b = 1)


###################################################
### code chunk number 15: robflreg.Rnw:537-547
###################################################
library(robflreg)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 3, n.gp = 101)
Y <- sim.data$Y
X <- sim.data$X

gp <- rep(list(seq(0, 1, length.out = 101)), 3) # grid points of Xs
model.fit <- rob.sf.reg(Y, X, emodel = "robust", fmodel = "tau", gp = gp)
coefs <- get.sf.coeffs(model.fit)
plot_sf_coeffs(object = coefs, b = 2)


###################################################
### code chunk number 16: robflreg.Rnw:550-560
###################################################
library(robflreg)
set.seed(123)
sim.data <- generate.sf.data(n = 400, n.pred = 3, n.gp = 101)
Y <- sim.data$Y
X <- sim.data$X

gp <- rep(list(seq(0, 1, length.out = 101)), 3) # grid points of Xs
model.fit <- rob.sf.reg(Y, X, emodel = "robust", fmodel = "tau", gp = gp)
coefs <- get.sf.coeffs(model.fit)
plot_sf_coeffs(object = coefs, b = 3)


###################################################
### code chunk number 17: robflreg.Rnw:652-664
###################################################
library(robflreg)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 3, n.curve = 200, n.gp = 101)
Y <- sim.data$Y
X <- sim.data$X

gpY = seq(0, 1, length.out = 101)
gpX <- rep(list(seq(0, 1, length.out = 101)), 3)
model.fit <- rob.ff.reg(Y, X, model = "full", emodel = "robust",
fmodel = "MM", gpY = gpY, gpX = gpX)
coefs <- get.ff.coeffs(model.fit)
plot_ff_coeffs(object = coefs, b = 1, phi = 5, theta = 40, cex.axis = 0.75)


###################################################
### code chunk number 18: robflreg.Rnw:667-679
###################################################
library(robflreg)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 3, n.curve = 200, n.gp = 101)
Y <- sim.data$Y
X <- sim.data$X

gpY = seq(0, 1, length.out = 101)
gpX <- rep(list(seq(0, 1, length.out = 101)), 3)
model.fit <- rob.ff.reg(Y, X, model = "full", emodel = "robust",
fmodel = "MM", gpY = gpY, gpX = gpX)
coefs <- get.ff.coeffs(model.fit)
plot_ff_coeffs(object = coefs, b = 2, phi = 5, theta = 40, cex.axis = 0.75)


###################################################
### code chunk number 19: robflreg.Rnw:682-694
###################################################
library(robflreg)
set.seed(123)
sim.data <- generate.ff.data(n.pred = 3, n.curve = 200, n.gp = 101)
Y <- sim.data$Y
X <- sim.data$X

gpY = seq(0, 1, length.out = 101)
gpX <- rep(list(seq(0, 1, length.out = 101)), 3)
model.fit <- rob.ff.reg(Y, X, model = "full", emodel = "robust",
fmodel = "MM", gpY = gpY, gpX = gpX)
coefs <- get.ff.coeffs(model.fit)
plot_ff_coeffs(object = coefs, b = 3, phi = 5, theta = 40, cex.axis = 0.75)


###################################################
### code chunk number 20: robflreg.Rnw:766-786
###################################################
set.seed(987)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)

Y<- sim.data$Y

X<- sim.data$X

gpY = seq(0, 1, length.out = 101) # grid points of Y
gpX <- rep(list(seq(0, 1, length.out = 101)), 5) # grid points of Xs

set.seed(123)
sim.data2 <- generate.ff.data(n.pred = 5, n.curve = 100, n.gp = 101)
out.index <- sample(1:100, 20)
Y[out.index,] <- sim.data2$Y[out.index,] + 5
for(i in 1:5)
  X[[i]][out.index,] <- sim.data2$X[[i]][out.index,]
model.classical <- rob.ff.reg(Y = Y, X = X, model = "full", emodel = "classical",
                       gpY = gpY, gpX = gpX)

rob.out.detect(object = model.classical, fplot = TRUE)


###################################################
### code chunk number 21: robflreg.Rnw:789-809
###################################################
set.seed(987)
sim.data <- generate.ff.data(n.pred = 5, n.curve = 200, n.gp = 101)

Y<- sim.data$Y

X<- sim.data$X

gpY = seq(0, 1, length.out = 101) # grid points of Y
gpX <- rep(list(seq(0, 1, length.out = 101)), 5) # grid points of Xs

set.seed(123)
sim.data2 <- generate.ff.data(n.pred = 5, n.curve = 100, n.gp = 101)
out.index <- sample(1:100, 20)
Y[out.index,] <- sim.data2$Y[out.index,] + 5
for(i in 1:5)
  X[[i]][out.index,] <- sim.data2$X[[i]][out.index,]

model.MM <- rob.ff.reg(Y = Y, X = X, model = "full", emodel = "robust", fmodel = "MM",
                       gpY = gpY, gpX = gpX)
rob.out.detect(object = model.MM, fplot = TRUE)


